package com.jiuqi.mde;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.mde.MDEDimensionSet;
import com.jiuqi.mde.MDEField;
import com.jiuqi.mde.MDEFieldSet;

public final class MDEDataInfo {
  private String name;
  
  private boolean temporary;
  
  private MDEDimensionSet dimensions;
  
  private boolean isunique = true;
  
  private MDEFieldSet fields;
  
  private MDEField indetyField;
  
  private Object[] defaultValues;
  
  public MDEDataInfo(String name) {
    this.name = name;
    this.dimensions = new MDEDimensionSet();
    this.fields = new MDEFieldSet();
  }
  
  public String getName() {
    return this.name;
  }
  
  public boolean isUnique() {
    return this.isunique;
  }
  
  public void setIsUnique(boolean unique) {
    this.isunique = unique;
  }
  
  public boolean isTemporary() {
    return this.temporary;
  }
  
  public void setIsTemporary(boolean temporary) {
    this.temporary = temporary;
  }
  
  public MDEDimensionSet dimensions() {
    return this.dimensions;
  }
  
  public MDEFieldSet fields() {
    return this.fields;
  }
  
  public MDEField getIndentyField() {
    return this.indetyField;
  }
  
  public void setIndetyField(MDEField field) {
    this.indetyField = field;
  }
  
  public void complete() {
    this.fields.complete();
    this.defaultValues = new Object[this.fields.size()];
  }
  
  public Object getDefaultValue(int index, Object value) {
    return this.defaultValues[index];
  }
  
  public void setDefaultValue(int index, Object value) {
    if (value instanceof String && ((String)value).length() == 0)
      value = null; 
    this.defaultValues[index] = value;
  }
  
  public boolean isDefaultValue(int index, Object value) {
    if (this.defaultValues[index] == value)
      return true; 
    if (value instanceof String && ((String)value).length() == 0)
      value = null; 
    return (value != null && value.equals(this.defaultValues[index]));
  }
}
